if select(2,UnitClass("player")) ~= "MONK" then return end
local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local Transcendence = AceAddon:GetAddon("Transcendence")

local LSM = LibStub("LibSharedMedia-3.0")
--------------------------------------------------------------------------------------
local CreateFrame = CreateFrame
local TRANSCENDENCE_TEXTURE
local TRANSCENDENCE_UNKNOWN_TEXTURE
local TRANSCENDENCE_TRANSFER_TEXTURE
local statusbar_texture="Interface\\TargetingFrame\\UI-StatusBar"
local TRANSFER_DISTANCE = 40
local TRANSFER_DISTANCE_SQUARED = TRANSFER_DISTANCE * TRANSFER_DISTANCE
local GetCVar = GetCVar
local UnitPosition = UnitPosition
local GetSpellInfo = GetSpellInfo
local select = select
local min = min
local max = max
local string_match = string.match
local string_format = string.format
local math_floor = math.floor
local math_sqrt = math.sqrt
local math_acos = math.acos
local math_sin = math.sin
local math_cos = math.cos
local math_atan2 = math.atan2
local GetTime = GetTime
local UnitGUID = UnitGUID
--------------------------------------------------------------------------------------
local two_pi = math.pi * 2
local Trd_frame = CreateFrame("Frame", nil , UIParent) 
local localized_transcendence_transfer = GetSpellInfo(119996)


local function save_Trd_frame_coord()
	Trd_frame:StopMovingOrSizing()
	Transcendence.db.profile.pos_left = Trd_frame:GetLeft()
	Transcendence.db.profile.pos_top = Trd_frame:GetTop()
end

function Transcendence:lock()
	if not Transcendence.db.profile.lock then
		Trd_frame:SetMovable(true)
		Trd_frame:EnableMouse(true)
		Trd_frame:SetScript("OnMouseDown", function() Trd_frame:StartMoving() end)
		Trd_frame:SetScript("OnMouseUp", save_Trd_frame_coord)
		Trd_frame:SetScript("OnDragStop", function() Trd_frame:StopMovingOrSizing() end)
	else
		Trd_frame:SetMovable(false)
		Trd_frame:EnableMouse(false)
		Trd_frame:SetScript("OnMouseDown", function() end)
		Trd_frame:SetScript("OnMouseUp", function() end)
		Trd_frame:SetScript("OnDragStop", function() end)
	end
end

local icon_texture
local direction
local distance
local cd
local icon_bg

function Transcendence:OnCoreInitialize()
	Trd_frame:SetFrameStrata("MEDIUM")
	Trd_frame:SetClampedToScreen(true)
	Trd_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",Transcendence.db.profile.pos_left,Transcendence.db.profile.pos_top);
	Trd_frame:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize) 

	Transcendence:lock()
	icon_bg = Trd_frame:CreateTexture(nil, "BACKGROUND")
	icon_bg:SetAllPoints(Trd_frame)
	icon_bg:SetTexture(statusbar_texture)
	icon_bg:SetVertexColor(0,0,0,1)
	icon_texture = Trd_frame:CreateTexture(nil, "BORDER")
	icon_texture:SetPoint("CENTER", Trd_frame, "CENTER",0,0)

	icon_texture:SetTexture(TRANSCENDENCE_TEXTURE)
	icon_texture:SetTexCoord(0.1,0.9,0.1,0.9)

	direction = Trd_frame:CreateTexture(nil, "OVERLAY") 
	direction:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize) 
	direction:SetTexture("Interface\\AddOns\\Transcendence\\texture\\Arrows32-32x32.tga") 
	direction:SetBlendMode("ADD") 
	direction:SetPoint("CENTER")

	distance = Trd_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	distance:SetPoint("CENTER", Trd_frame, "CENTER",0, 0)
	
	cd = Trd_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	cd:SetPoint("BOTTOM", Trd_frame, "BOTTOM",0,5)
	cd:SetTextColor(1,1,1,1)
	
	Transcendence:UpdateDB()
end
local spirit_location_x,spirit_location_y,spirit_location_flr,spirit_location_map  = nil,nil,nil,nil
function Transcendence:COMBAT_LOG_EVENT_UNFILTERED(...)
	if select(5, ...) == UnitGUID("player") then
		if(select(3, ...)=="SPELL_AURA_REMOVED" and select(13, ...) == 101643)
		then
			spirit_location_x,spirit_location_y,spirit_location_flr,spirit_location_map = nil,nil,nil,nil
		end
	end
end

function Transcendence:ZONE_CHANGED_NEW_AREA()
	spirit_location_x,spirit_location_y,spirit_location_flr,spirit_location_map = nil,nil,nil,nil
end
local lineID = nil

local slt_x,slt_y,slt_flr,slt_map

function Transcendence:UNIT_SPELLCAST_SUCCEEDED(...)
	if select(2,...)=="player" then
		local spellId = select(6,...)
		if spellId==101643 then
			spirit_location_x,spirit_location_y,spirit_location_flr,spirit_location_map = UnitPosition("player")
		elseif spellId == 119996 then
			if lineID and select(4,...) == lineID then
				spirit_location_x,spirit_location_y,spirit_location_flr,spirit_location_map=slt_x,slt_y,slt_flr,slt_map
			else
				spirit_location_x,spirit_location_y,spirit_location_flr,spirit_location_map=UnitPosition("player")
			end
			lineID = nil
			slt_x,slt_y,slt_flr,slt_map = nil,nil,nil,nil
		end
	end
end

function Transcendence:UNIT_SPELLCAST_SENT(...)
	local _,unit,spell,lid = ...
	if unit=="player" then
		if spell==localized_transcendence_transfer then
			lineID = lid
			slt_x,slt_y,slt_flr,slt_map = UnitPosition("player")
		end
	end
end

function Transcendence:refresh_font_size()
	distance:SetFont(LSM:HashTable("font")[Transcendence.db.profile.disFont], Transcendence.db.profile.fontSize, "OUTLINE")
end

function Transcendence:refresh_cd_font_size()
	cd:SetFont(LSM:HashTable("font")[Transcendence.db.profile.cdFont], Transcendence.db.profile.cdFontSize, "OUTLINE")
end

function Transcendence:refresh_icon_size()
	Trd_frame:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize) 
	icon_texture:SetSize(Transcendence.db.profile.iconSize-4,Transcendence.db.profile.iconSize-4) 
	direction:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize)
	direction:SetVertexColor(Transcendence.db.profile.arrowColorr,Transcendence.db.profile.arrowColorg,Transcendence.db.profile.arrowColorb,Transcendence.db.profile.arrowColora)
end

function Transcendence:refresh_location()
	Trd_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",Transcendence.db.profile.pos_left,Transcendence.db.profile.pos_top);
end

local dis_fixed_precision_str
local cd_fixed_precision_str
function Transcendence:refresh_dis_fixed_precision()
	dis_fixed_precision_str = string_format("%%.%df",Transcendence.db.profile.disFixedPrecision)
end

function Transcendence:refresh_cd_fixed_precision()
	cd_fixed_precision_str = string_format("%%.%df",Transcendence.db.profile.cdFixedPrecision)
end

local update_timer =0 
local refresh_rate = .1
function Transcendence:refresh_TRANSFER_DISTANCE()
	TRANSFER_DISTANCE = 40 * Transcendence.db.profile.mapErrorFactor
	TRANSFER_DISTANCE_SQUARED = TRANSFER_DISTANCE * TRANSFER_DISTANCE
end

function Transcendence:refresh_rate_modified()
	update_timer = 0
	refresh_rate = Transcendence.db.profile.refreshRate
end
local long_distance

function Transcendence:refresh_LONG_DISTANCE()
	long_distance = Transcendence.db.profile.longDistance
	long_distance = long_distance * long_distance
end
local enable_cd
function Transcendence:refresh_enable_cd()
	enable_cd = Transcendence.db.profile.enableCD
end

local short_distance_color_r,short_distance_color_g,short_distance_color_b,short_distance_color_a
function Transcendence:refresh_SHORT_DISTANCE_COLOR()
	short_distance_color_r,short_distance_color_g,short_distance_color_b,short_distance_color_a = Transcendence.db.profile.shortDistanceColorr,Transcendence.db.profile.shortDistanceColorg,Transcendence.db.profile.shortDistanceColorb,Transcendence.db.profile.shortDistanceColora
end

local middle_distance_color_r,middle_distance_color_g,middle_distance_color_b,middle_distance_color_a
function Transcendence:refresh_MIDDLE_DISTANCE_COLOR()
	middle_distance_color_r,middle_distance_color_g,middle_distance_color_b,middle_distance_color_a = Transcendence.db.profile.middleDistanceColorr,Transcendence.db.profile.middleDistanceColorg,Transcendence.db.profile.middleDistanceColorb,Transcendence.db.profile.middleDistanceColora
end

local long_distance_color_r,long_distance_color_g,long_distance_color_b,long_distance_color_a
function Transcendence:refresh_LONG_DISTANCE_COLOR()
	long_distance_color_r,long_distance_color_g,long_distance_color_b,long_distance_color_a = Transcendence.db.profile.longDistanceColorr,Transcendence.db.profile.longDistanceColorg,Transcendence.db.profile.longDistanceColorb,Transcendence.db.profile.longDistanceColora
end

function Transcendence:refresh_Transfer_Image()
	TRANSCENDENCE_TRANSFER_TEXTURE = Transcendence.db.profile.transferImage
end

function Transcendence:refresh_Unknown_Transfer_Image()
	TRANSCENDENCE_UNKNOWN_TEXTURE = Transcendence.db.profile.unknownTransferImage
end

function Transcendence:refresh_No_Transfer_Image()
	TRANSCENDENCE_TEXTURE = Transcendence.db.profile.noTransferImage
end

local readyCD
function Transcendence:refresh_ReadyCD()
	readyCD = Transcendence.db.profile.readyCD
end

local cd_font_colorr,cd_font_colorg,cd_font_colorb,cd_font_colora
function Transcendence:refresh_cdFontColor()
	cd_font_colorr,cd_font_colorg,cd_font_colorb,cd_font_colora =
		Transcendence.db.profile.cdFontColorr,Transcendence.db.profile.cdFontColorg,Transcendence.db.profile.cdFontColorb,Transcendence.db.profile.cdFontColora
end

local cd_ready_font_colorr,cd_ready_font_colorg,cd_ready_font_colorb,cd_ready_font_colora
function Transcendence:refresh_cdReadyFontColor()
	cd_ready_font_colorr,cd_ready_font_colorg,cd_ready_font_colorb,cd_ready_font_colora=
		Transcendence.db.profile.cdReadyFontr,Transcendence.db.profile.cdReadyFontg,Transcendence.db.profile.cdReadyFontb,Transcendence.db.profile.cdReadyFonta
end

local cd_font_colorr,cd_font_colorg,cd_font_colorb,cd_font_colora

function Transcendence:refresh_cdFontColor()
	cd_font_colorr,cd_font_colorg,cd_font_colorb,cd_font_colora =
		Transcendence.db.profile.cdFontColorr,Transcendence.db.profile.cdFontColorg,Transcendence.db.profile.cdFontColorb,Transcendence.db.profile.cdFontColora
end
function Transcendence:UpdateDB()
	Transcendence:lock()
	Transcendence:refresh_location()
	Transcendence:refresh_TRANSFER_DISTANCE()
	Transcendence:refresh_rate_modified()
	Transcendence:refresh_font_size()
	Transcendence:refresh_cd_font_size()
	Transcendence:refresh_icon_size()
	Transcendence:refresh_dis_fixed_precision()
	Transcendence:refresh_enable_cd()
	Transcendence:refresh_cd_fixed_precision()
	Transcendence:refresh_LONG_DISTANCE()
	Transcendence:refresh_SHORT_DISTANCE_COLOR()
	Transcendence:refresh_MIDDLE_DISTANCE_COLOR()
	Transcendence:refresh_LONG_DISTANCE_COLOR()
	Transcendence:refresh_Transfer_Image()
	Transcendence:refresh_Unknown_Transfer_Image()
	Transcendence:refresh_No_Transfer_Image()
	Transcendence:refresh_ReadyCD()
	Transcendence:refresh_cdReadyFontColor()
	Transcendence:refresh_cdFontColor()
end

local function update_main()
	local x,y,flr,map = UnitPosition("player")
	if flr== spirit_location_flr and map == spirit_location_map
	then
		local dx = spirit_location_x - x
		local dy = spirit_location_y - y
		local distance_squared = dx *dx + dy  *dy 
		distance:SetText(string_format(dis_fixed_precision_str,math_sqrt(distance_squared)))
		if distance_squared == 0
		then
			if IsUsableSpell(119996)==true
			then
				icon_texture:SetTexture(TRANSCENDENCE_TRANSFER_TEXTURE)
			else
				icon_texture:SetTexture(TRANSCENDENCE_TEXTURE)
			end
			distance:SetTextColor(short_distance_color_r,short_distance_color_g,short_distance_color_b,short_distance_color_a)
			direction:Hide()
		else
			-- Thanks for Grid2 (StatusDirection) 's wonderful code and wonderful arrow tga!!
			local dir_tex = (math_floor( (math_atan2(dy,dx)-GetPlayerFacing()) / two_pi * 32 + 0.5) % 32)/32
			direction:SetTexCoord(.05, 0.95, dir_tex+0.0015625, dir_tex+0.028125)
			if distance_squared <= 1600 and IsUsableSpell(119996)==true
			then
				icon_texture:SetTexture(TRANSCENDENCE_TRANSFER_TEXTURE)
				distance:SetTextColor(short_distance_color_r,short_distance_color_g,short_distance_color_b,short_distance_color_a)
				direction:Show()
			else
				if distance_squared < TRANSFER_DISTANCE_SQUARED
				then
					icon_texture:SetTexture(TRANSCENDENCE_UNKNOWN_TEXTURE)
					distance:SetTextColor(short_distance_color_r,short_distance_color_g,short_distance_color_b,short_distance_color_a)
					direction:Show()
				else
					icon_texture:SetTexture(TRANSCENDENCE_TEXTURE)
					direction:Show()
					if long_distance< distance_squared
					then
						distance:SetTextColor(long_distance_color_r,long_distance_color_g,long_distance_color_b,long_distance_color_a)
					else
						distance:SetTextColor(middle_distance_color_r,middle_distance_color_g,middle_distance_color_b,middle_distance_color_a)
					end
				end
			end
		end
		if enable_cd and enable_cd == true then
			local start, duration = GetSpellCooldown(119996)
			local lasttm = start + duration - GetTime()
			if 1.5 < duration and 0<= lasttm  then
				cd:SetText(string_format(cd_fixed_precision_str,lasttm))
				if lasttm < readyCD then
					cd:SetTextColor(cd_ready_font_colorr,cd_ready_font_colorg,cd_ready_font_colorb,cd_ready_font_colora)
				else
					cd:SetTextColor(cd_font_colorr,cd_font_colorg,cd_font_colorb,cd_font_colora)
				end
			else
				cd:SetText("")
			end
		else
			cd:SetText("")
		end
		Trd_frame:Show()
	else
		Trd_frame:Hide()
	end
end

local update_frame = CreateFrame("Frame")
local function on_update(this, elapsed)
	update_timer = update_timer + elapsed
	if refresh_rate <= update_timer then
		if spirit_location_x then
			update_main()
		else
			Trd_frame:Hide()
		end
		update_timer = 0
	end
end
update_frame:SetScript("OnUpdate", on_update)
