if select(2,UnitClass("player")) ~= "MONK" then return end

local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local AceDB = LibStub("AceDB-3.0")
local string_match= string.match
local tonumber = tonumber
local AceConfigCmd = LibStub("AceConfigCmd-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local GetCVar = GetCVar
--------------------------------------------------------------------------------------
local cvar_width,cvar_height = string_match(GetCVar("gxResolution"), "(%d+)x(%d+)")
cvar_width = tonumber(cvar_width)
cvar_height = tonumber(cvar_height)
local cvar_min = min(cvar_width,cvar_height)
--------------------------------------------------------------------------------------
local Transcendence = AceAddon:NewAddon("Transcendence", "AceEvent-3.0","AceConsole-3.0")
local LSM = LibStub("LibSharedMedia-3.0")

local default_options=
{
	profile = 
	{
		lock = false,
		pos_left = cvar_width / 3 * 2,
		pos_top = cvar_height / 2,
		mapErrorFactor = 0.95,
		refreshRate = 0.1,
		fontSize = 30,
		cdFontSize = 15,
		iconSize = 65,
		disFixedPrecision = 0,
		cdFixedPrecision = 1,
		arrowColorr = 1,
		arrowColorg = 1,
		arrowColorb = 1,
		arrowColora = 1,
		enableCD = true,
		longDistance = 80,
		disFont = LSM:GetDefault("font"),
		cdFont = LSM:GetDefault("font"),
		transferImage = "Interface\\Icons\\monk_stance_redcrane",
		unknownTransferImage = "Interface\\Icons\\ability_monk_roll",
		noTransferImage = "Interface\\Icons\\monk_ability_transcendence",
		readyCD = 3,
		cdReadyFontr= 1,
		cdReadyFontg= 0,
		cdReadyFontb= 0,
		cdReadyFonta= 1,
		cdFontColorr= 1,
		cdFontColorg= 1,
		cdFontColorb= 1,
		cdFontColora= 1,
		shortDistanceColorr = 0,
		shortDistanceColorg = 1,
		shortDistanceColorb = 0,
		shortDistanceColora = 1,
		middleDistanceColorr = 1,
		middleDistanceColorg = 1,
		middleDistanceColorb = 0,
		middleDistanceColora = 1,
		longDistanceColorr = 1,
		longDistanceColorg = 1,
		longDistanceColorb = 0,
		longDistanceColora = 1,
		longDistanceColorr = 1,
		longDistanceColorg = 0,
		longDistanceColorb = 0,
		longDistanceColora = 1,
	}
}


function Transcendence:OnInitialize()
	self.db = AceDB:New("TranscendenceDB", default_options,true)
	self:OnCoreInitialize()
	self:RegisterChatCommand("Transcendence", "ChatCommand")
	self:RegisterChatCommand("TRD", "ChatCommand")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
end
function Transcendence:ChatCommand(input)
	if IsAddOnLoaded("Transcendence_Options") == false then
		local loaded , reason = LoadAddOn("Transcendence_Options")
		if loaded == false then
			self:Print("Transcendence_Options: "..reason)
			return
		end
	end
	if not input or input:trim() == "" then
		AceConfigDialog:Open("Transcendence")
	else
		AceConfigCmd:HandleCommand("Transcendence", "Transcendence","")
		AceConfigCmd:HandleCommand("Transcendence", "Transcendence",input)
	end
end